﻿###########################################
#Title: AdminChat 
#Author: Bass-Driver
#Version: V1.3
###########################################
#Changelog:
#Version V1.0: First release(Private)
#Version V1.1: Sort messages fix by Yisc[NL]
#Version V1.2: Add Scrollbuttons
#Version V1.3: First Public Release
###########################################

CatchEvent OnMSO( $userName, $text ) # Player event

	$idxOfFirtsSpace = indexOf( $text, " ");

	IF( $idxOfFirtsSpace == -1 )
	THEN
	  $command = $text;
	  $argv = "";
	ELSE
	  $command = subStr( $text,0,$idxOfFirtsSpace );
	  $argv = trim( subStr( $text,$idxOfFirtsSpace ) );
	ENDIF

	SWITCH( $command )
            CASE "!adminchat":
            CASE "!adchat":
				IF ( UserIsAdmin( $userName ) == 1 ) THEN #Check if user is a Admin (Server/Insim Admin)
					IF ((GetCurrentPlayerVar("InAdminChat") == 0)||(GetCurrentPlayerVar("InAdminChat") == "")) THEN
					SetCurrentPlayerVar("InAdminChat", 1);
					AdminChatWindow(0,0);
					$InAdminChat = getListOfPlayers("N");
						FOREACH ( $maVar IN $InAdminChat )
							IF (GetPlayerVar($maVar["value"],"InAdminChat") == 1) THEN
								privMsg ( $maVar["value"] ,"".GetPlayerVar($userName,"NickName"). " ^8joined the adminchat!");
							ENDIF
						ENDFOREACH
					ELSE
						privmsg("^8You already joined the adminchat!");
					ENDIF
				ELSE
					privmsg("^1Access Deniend");
				ENDIF
               BREAK;
	ENDSWITCH
EndCatchEvent

CatchEvent OnLapperStart()
	Init_AdminChat();
	GlobalVar $Adminchat_Version;  $Adminchat_Version = "V1.3";
EndCatchEvent

Sub Init_AdminChat()
	#Initializing AdminChat Settings.
	GlobalVar $message_id_adchat;
	GlobalVar $CloseAdminChat;
	GlobalVar $MaxOfMessages;
	GlobalVar $Dir;
	GlobalVar $HT;
	GlobalVar $HTT;
	
	$CloseAdminChat = "&Close"; #CloseButtons Var
	
	#File Load Settings
	$Dir["AdminChat"] = "Adminchat/Logs/AdminChat/".getLapperVar( "LongDate" ).".txt"; #directory of Admin Chatlogs
	UserGroupFromFile( "AdminChat",$Dir["AdminChat"]); # Load File
	
	$ListAdminChat = GetListOfUsersGroup(AdminChat); 
	$MaxOfMessages = arrayCount($ListAdminChat);
	
	#Load MessageID_Count for message sequence
	$message_id_adchat = ToNum( GetStoredValue( "MESSAGE_ID_ADCHAT" ));### Load stored values and give them a default setting if no stored value has been found ###
	IF (($message_id_adchat == NULL)||($message_id_adchat > 60)) THEN
	  $message_id_adchat=10;
	ENDIF
EndSub

Sub AdminChatWindow($keyflags,$id)
	#Design
	openPrivButton( "bgd",60,50,80,64,1,-1,16,"");
	openPrivButton( "Title",61,51,78,5,1,-1,32,"^3AdminChat");
	openPrivButton( "TitleFileDate",61,52,30,4,1,-1,64,"".$Adminchat_Version."  ^8".getLapperVar( "LongDate" )." / ".getLapperVar( "ShortTime" ) );
	openPrivButton( "CloseAC",133,50,6,7,1,-1,128,"^1×",CloseAdminChat);
	openPrivButton( "Chatbgd",61,56,75,50,1,-1,32,"");
	openPrivButton( "Scroll",136,61,3,40,1,-1,16,"");
	openPrivTextButton( "WriteMessage",61,106,78,7,1,32,"^0Write Message","^2Write Message",50,WriteAdminMessage);
	
	openPrivButton( "users_bgd",40,50,20,64,1,-1,16,"");
	openPrivButton( "users_Title",41,51,18,5,1,-1,32,"^3Users in chat:");
	
	$ListAdminChat = GetListOfUsersGroup(AdminChat); 
	$MaxOfMessages = arrayCount($ListAdminChat)-1; # Lower count by one, to exclude empty line
	
	LoadAdminChatFromFile(0,0);#Load messages from file.
EndSub

Sub WriteAdminMessage( $KeyFlags,$argv  )
	#Get/Set data from/to file 

	MoveUserToGroup( "AdminChat", $message_id_adchat."|".getLapperVar( "ShortTime" ) ."|". GetCurrentPlayerVar( "UserName" )."|".$argv);
	UserGroupToFile( "AdminChat", $Dir["AdminChat"]);
 
	$MaxOfMessages = $MaxOfMessages+1; #Amount of messages in file + 1;
	
	### Raise MessageID by 1 and store it into the database ###
	$message_id_adchat=$message_id_adchat+1;
	SetStoredValue( "MESSAGE_ID_ADCHAT", ToNum( $message_id_adchat ) );
    
	LoadAdminChatFromFile(0,0); #Load messages from file.
EndSub

Sub LoadAdminChatFromFile($keyflags,$id)
	closePrivButton($CloseAdminChat); #Refresh buttons
	$ListAdminChat = GetListOfUsersGroup(AdminChat);
    $HTT = 57; #Height of the First User
	$i=0;
	#$Record[0] = MessageID;
	#$Record[1] = Date/Time;
	#$Record[2] = Username;
	#$Record[3] = Message;
	
    $InAdminChat = getListOfPlayers("U");
	FOREACH( $maVar IN $InAdminChat )
	
	#USERLIST TEST
		IF(GetPlayerVar($maVar["value"],"InAdminChat") == 1) THEN
		
			openPrivButton("userlist_".$i,41,$HTT,18,4,4,-1,32,"".GetPlayerVar($maVar["value"],"NickName")); #Show Message
			$CloseAdminChat = $CloseAdminChat."&userlist_".$i;
			$HTT = $HTT+4; #ButtonHeight+4
					
			$HT = 57; #Height of first message
			FOR ($ShowMessage=$MaxOfMessages-12; $ShowMessage<$MaxOfMessages; $ShowMessage=$ShowMessage+1 ) #Last Message on bottomline.
				IF ($ListAdminChat[$ShowMessage] != "") THEN #Stops loading empty buttons
				
					closeButton($maVar["value"],"aploglist_".$MaxOfMessages-13); #Close first button that cause overlap.
					
					$Record = SplitToArray($ListAdminChat[$ShowMessage], "|");
					openButton($maVar["value"], "aploglist_".$ShowMessage,61,$HT,75,4,4,-1,64,"^3".$Record[1]." ^8".GetPlayerVar($Record[2],"NickName").": ^7".$Record[3]); #Show Message
					
					$CloseAdminChat = $CloseAdminChat."&aploglist_".$ShowMessage; 
					$HT = $HT+4; #ButtonHeight+4
				ENDIF
			ENDFOR
			
		ENDIF
	$i=$i+1;
	ENDFOREACH
	
######SCROLLBUTTONS######
	
	#ScrollButton UP
		IF ($ShowMessage == 12)THEN
			openPrivButton( "ScrollUp",136,56,3,5,1,-1,16, "^H^1¡¶");
		ELSE
			openPrivButton( "ScrollUp",136,56,3,5,1,-1,16, "^H^0¡¶",AdminChatLogsScrollUp);
		ENDIF
	#ScrollButton Down
		IF ($ListAdminChat[$ShowMessage] == "") THEN
			openPrivButton( "ScrollDown",136,101,3,5,1,-1,16, "^H^1¡¿");
		ELSE
			openPrivButton( "ScrollDown",136,101,3,5,1,-1,16, "^H^0¡¿",AdminChatLogsScrollDown);
		ENDIF
EndSub
########################################
#ScrollButtons Sub-Routines
########################################
Sub AdminChatLogsScrollUp ( $KeyFlags,$id  )
	$MaxOfMessages=$MaxOfMessages-1;
	LoadAdminChatFromFile(0,0);
EndSub

Sub AdminChatLogsScrollDown ( $KeyFlags,$id  )
	$MaxOfMessages=$MaxOfMessages+1;
	LoadAdminChatFromFile(0,0);
EndSub

########################################
#Close Buttons SUB
########################################
Sub CloseAdminChat($keyflags,$id)
	$InAdminChat = getListOfPlayers("N");
	FOREACH( $maVar IN $InAdminChat )
		IF(GetPlayerVar($maVar["value"],"InAdminChat") == 1) THEN
			privMsg ( $maVar["value"] ,"".GetCurrentPlayerVar("NickName"). " ^8left the adminchat!");
		ENDIF
	ENDFOREACH
	SetCurrentPlayerVar("InAdminChat", 0);
	closePrivButton("bgd&Title&CloseAC&Chatbgd&WriteMessage&ScrollUp&Scroll&ScrollDown&TitleFileDate&users_bgd&users_Title");
	closePrivButton($CloseAdminChat);
EndSub
